diff --git a/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandWhoIs.java b/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandWhoIs.java
index d8dcc8dbc..041a3734d 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandWhoIs.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/commands/CommandWhoIs.java
@@ -2,8 +2,8 @@ package net.minecraft.server.net.command.commands;
 
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
-import com.mojang.brigadier.builder.LiteralArgumentBuilder;
-import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.builder.ArgumentBuilderLiteral;
+import com.mojang.brigadier.builder.ArgumentBuilderRequired;
 import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandManager;
@@ -14,17 +14,20 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 
 public class CommandWhoIs implements CommandManager.CommandRegistry {
     public void register(CommandDispatcher<CommandSource> dispatcher) {
-        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("whois")
-                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", ArgumentTypeEntity.player())
-                        .executes(c -> {
-                            CommandSource source = c.getSource();
-                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
-                            Player player = (Player) entitySelector.get(source).get(0);
+        CommandNode<CommandSource> command = dispatcher.register(ArgumentBuilderLiteral.<CommandSource>literal("whois")
+            .then(ArgumentBuilderRequired.<CommandSource, EntitySelector>argument("target", ArgumentTypeEntity.nickname())
+                .executes(c ->
+                    {
+                        CommandSource source = c.getSource();
+                        EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                        Player player = (Player) entitySelector.get(source).get(0);
 
-                            source.sendTranslatableMessage("command.commands.whois.success", CommandHelper.getEntityName(player), player.username);
-                            return Command.SINGLE_SUCCESS;
-                        })));
-        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("realname")
-                .redirect(command));
+                        source.sendTranslatableMessage("command.commands.whois.success", CommandHelper.getEntityName(player), player.username);
+                        return Command.SINGLE_SUCCESS;
+                    }
+                )
+            )
+        );
+        dispatcher.register(ArgumentBuilderLiteral.<CommandSource>literal("realname").redirect(command));
     }
 }
diff --git a/gradle/libs.versions.toml b/gradle/libs.versions.toml
index c536f6277..1b50d95b0 100644
--- a/gradle/libs.versions.toml
+++ b/gradle/libs.versions.toml
@@ -5,7 +5,7 @@ lwjgl = "3.3.4"
 [libraries]
 jetbrains-annotations = { module = "org.jetbrains:annotations", version = "24.0.0" }
 gson = { module = "com.google.code.gson:gson", version = "2.10.1" }
-brigadier = { module = "com.mojang:brigadier", version = "1.0.18" }
+brigadier = { module = "bta-brigadier:bta-brigadier", version = "1.0.1"}
 slf4j-api = { module = "org.slf4j:slf4j-api", version = "2.0.7" }
 log4j-core = { module = "org.apache.logging.log4j:log4j-core", version.ref = "log4j" }
 log4j-api = { module = "org.apache.logging.log4j:log4j-api", version.ref = "log4j" }
diff --git a/util/datagen/build.gradle.kts b/util/datagen/build.gradle.kts
index 6f0db8857..b24a50db5 100644
--- a/util/datagen/build.gradle.kts
+++ b/util/datagen/build.gradle.kts
@@ -5,11 +5,20 @@ plugins {
 repositories {
     mavenCentral()
     maven("https://libraries.minecraft.net/")
+    ivy {
+        url = uri("https://github.com/Better-than-Adventure")
+        patternLayout {
+            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
 }
 
 dependencies {
     implementation(project(":game:core"))
 
+    implementation(libs.brigadier)
     implementation(libs.gson)
     implementation(libs.jetbrains.annotations)
 }
diff --git a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 58feeca8d..0b64c0ae7 100644
--- a/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/util/datagen/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -39,6 +39,7 @@ class WorkbenchGenerator {
         generateStairs();
 
         generateDoors();
+        generateSigns();
         generateTrapDoors();
         generateFences();
         generateFenceGates();
@@ -193,7 +194,7 @@ class WorkbenchGenerator {
                 "XXX")
             .addInput('X', Items.STICK)
             .addInput('W', "minecraft:wools")
-            .create("painting", Items.PAINTING.getDefaultStack());
+            .create("painting", new ItemStack(Items.PAINTING, 1, Items.PAINTING.getMaxDamage()));
 
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -229,15 +230,6 @@ class WorkbenchGenerator {
             .addInput('X', Items.STICK)
             .create("ladder", new ItemStack(Blocks.LADDER_OAK, 2));
 
-        RecipeBuilder.Shaped(CORE_NAMESPACE)
-            .setShape(
-                "XXX",
-                "XXX",
-                " # ")
-            .addInput('X', "minecraft:planks")
-            .addInput('#', Items.STICK)
-            .create("sign", new ItemStack(Items.SIGN, 4));
-
         RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
                 "# #",
@@ -383,6 +375,11 @@ class WorkbenchGenerator {
             .addInput(Items.BUCKET_WATER)
             .create("sponge_to_wet_sponge", Blocks.SPONGE_WET.getDefaultStack());
 
+        RecipeBuilder.Shapeless(CORE_NAMESPACE)
+            .addInput(Blocks.PUMICE_DRY)
+            .addInput(Items.BUCKET_LAVA)
+            .create("pumice_to_wet_pumice", Blocks.PUMICE_WET.getDefaultStack());
+
         RecipeBuilder.Shapeless(CORE_NAMESPACE)
             .addInput(Blocks.PUMPKIN)
             .create("pumpkin_to_pumpkin_seeds", new ItemStack(Items.SEEDS_PUMPKIN, 4));
@@ -872,6 +869,22 @@ class WorkbenchGenerator {
         door.addInput('X', Items.INGOT_STEEL_CRUDE).create("steel_door", new ItemStack(Items.DOOR_STEEL, stackSize));
     }
 
+    private static void generateSigns() {
+        RecipeBuilderShaped sign = RecipeBuilder.Shaped(CORE_NAMESPACE)
+            .setShape(
+                "XXX",
+                "XXX",
+                " # ")
+            .addInput('#', Items.STICK);
+        final int stackSize = 4;
+
+        sign.addInput('X', Blocks.PLANKS_OAK)
+            .create("sign", new ItemStack(Items.SIGN, stackSize));
+        for (final DyeColor color : DyeColor.values()) {
+            sign.addInput('X', Blocks.PLANKS_OAK_PAINTED, color.blockMeta).create(color.colorID + "_sign", new ItemStack(Items.SIGN_PAINTED, stackSize, color.itemMeta));
+        }
+    }
+
     private static void generateTrapDoors() {
         RecipeBuilderShaped door = RecipeBuilder.Shaped(CORE_NAMESPACE)
             .setShape(
@@ -1335,12 +1348,15 @@ class WorkbenchGenerator {
         final String format = "%s_undyeing";
 
         Registries.RECIPES.WORKBENCH.register(String.format(format, "planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:planks"), new ItemStack(Blocks.PLANKS_OAK)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "signs"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:signs"), new ItemStack(Items.SIGN)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "doors"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:doors"), new ItemStack(Items.DOOR_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "stairs_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:stairs_planks"), new ItemStack(Blocks.STAIRS_PLANKS_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "slabs_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:slabs_planks"), new ItemStack(Blocks.SLAB_PLANKS_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "fences_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fences_planks"), new ItemStack(Blocks.FENCE_PLANKS_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "fence_gates_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:fence_gates_planks"), new ItemStack(Blocks.FENCE_GATE_PLANKS_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "trapdoor_planks"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:trapdoor_planks"), new ItemStack(Blocks.TRAPDOOR_PLANKS_OAK)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps"), new ItemStack(Blocks.LAMP_IDLE)));
+        Registries.RECIPES.WORKBENCH.register(String.format(format, "lamps_inverted"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:lamps_inverted"), new ItemStack(Blocks.LAMP_INVERTED_IDLE)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "wools"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:wools"), new ItemStack(Blocks.WOOL)));
         Registries.RECIPES.WORKBENCH.register(String.format(format, "chests"), new RecipeEntryUndyeing(new RecipeSymbol("minecraft:chests"), new ItemStack(Blocks.CHEST_PLANKS_OAK)));
     }
diff --git a/util/seed-viewer/build.gradle.kts b/util/seed-viewer/build.gradle.kts
index 460853a3b..b71d5edae 100644
--- a/util/seed-viewer/build.gradle.kts
+++ b/util/seed-viewer/build.gradle.kts
@@ -14,12 +14,22 @@ val include: Configuration by configurations.creating
 repositories {
     mavenCentral()
     maven("https://libraries.minecraft.net/")
+    ivy {
+        url = uri("https://github.com/Better-than-Adventure")
+        patternLayout {
+            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
 }
 
 dependencies {
     testImplementation(platform("org.junit:junit-bom:5.10.0"))
     testImplementation("org.junit.jupiter:junit-jupiter")
 
+    implementation(libs.brigadier)?.let { include(it) }
+
     implementation(project(":game:core"))?.let { include(it) }
     implementation(project(":util:logging"))?.let { include(it) }
     implementation(project(":util:nbt"))?.let { include(it) }
diff --git a/util/stellar/build.gradle.kts b/util/stellar/build.gradle.kts
index 539c067b5..27d57c62f 100644
--- a/util/stellar/build.gradle.kts
+++ b/util/stellar/build.gradle.kts
@@ -5,11 +5,21 @@ plugins {
 repositories {
     mavenCentral()
     maven("https://libraries.minecraft.net/")
+    ivy {
+        url = uri("https://github.com/Better-than-Adventure")
+        patternLayout {
+            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
 }
 
 dependencies {
     implementation(project(":game:core"))
 
+    implementation(libs.brigadier)
+
     implementation(libs.bundles.lwjgl)
     for (lib in libs.bundles.lwjgl.get()) {
         runtimeOnly(lib.group, lib.name, classifier = rootProject.ext["lwjglNatives"].toString())
